/* 
 * File:   AMS program
 * Author: Eric Fernandez
 *
 * Created on November 26, 2018, 5:19 PM
 */

#include <xc.h>
#include "configbits-16ex8.h"
#include "SDlib16.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/attribs.h>
/*
 * 
 */
int pec15Table[256];
int CRC15_POLY = 0x4599;

void init_PEC15_Table(){
int i =0, bit =0;
int remainder;
for (i = 0; i < 256; i++)
{
	remainder = i << 7;
	for (bit = 8; bit > 0; --bit)
	{
		if (remainder & 0x4000)
		{
			remainder = ((remainder << 1));
			remainder = (remainder ^ CRC15_POLY);
		}
		else{
			remainder = ((remainder << 1));
		}
	}
	pec15Table[i] = remainder&0xFFFF;
}
}

unsigned int pec15 (char *data , int len)
{
int remainder,address,i;
remainder = 16;//PEC seed
	for (i = 0; i < len; i++){
	address = ((remainder >> 7) ^ data[i]) & 0xFF;//calculate PEC table address
	remainder = (remainder << 8 ) ^ pec15Table[address];
	}
return (remainder*2);
//The CRC15 has a 0 in the LSB so the final value must be multiplied by 2
}

void initSPI(void);
short WriteReadSPI(unsigned short i);
void WakeUpAMS(void);
void killTime(void);
void init_PEC15_Table();
short ReadSPI(unsigned short i);
void checkVolts(void);
void ReadPWMRegister(void);



#define CS LATEbits.LATE5 // For PIC695
#define CS_test LATEbits.LATE7 

//#define LED LATDbits.LATD1

/* DONE FOR 4 BOARDS ///////////////////////////////////////////////////////
 * :: NEED TO ADJUST OV Value //////////////////////////////////////////////
 * :: MIGHT NEED TO ADJUST PEC INDIVIDUALLY *///////////////////////////////
float currentTemp=0, savedTemp;
float endSum;
unsigned short sumAll = 0;
unsigned short Vreg1=0,Vreg2=0,Vreg3=0,Vreg4=0;
unsigned short tempFinal=0;
unsigned char T_charge=0;
void writeOV(void){
// Read Config A
    CS=0;
    CS_test = CS;

    //Write command
	WriteReadSPI(0x00);
	WriteReadSPI(0x02);
    // Write PEC
	char  x[2] = {0x00,0x02};
	unsigned short u = pec15(x,2);	
	unsigned short highbyte = (u >> 8);
	unsigned short lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Need to put u into the SPI
    // Get Config A values
	unsigned short x1=0, x2=0, x3=0, x4=0, x5=0, x6=0, xPEC1 =0, xPEC0 = 0;
    unsigned short x1b=0, x2b=0, x3b=0, x4b=0, x5b=0, x6b=0, xPEC1b =0, xPEC0b = 0;
	unsigned short x1c=0, x2c=0, x3c=0, x4c=0, x5c=0, x6c=0, xPEC1c =0, xPEC0c = 0;
    unsigned short x1d=0, x2d=0, x3d=0, x4d=0, x5d=0, x6d=0, xPEC1d =0, xPEC0d = 0;
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1b = ReadSPI(0x00);
	x2b = ReadSPI(0x00);
	x3b = ReadSPI(0x00);
    x4b = ReadSPI(0x00);
	x5b = ReadSPI(0x00);
	x6b = ReadSPI(0x00);
	xPEC1b = ReadSPI(0x00);
	xPEC0b = ReadSPI(0x00);
    x1c = ReadSPI(0x00);
	x2c = ReadSPI(0x00);
	x3c = ReadSPI(0x00);
	x4c = ReadSPI(0x00);
	x5c = ReadSPI(0x00);
	x6c = ReadSPI(0x00);
	xPEC1c = ReadSPI(0x00);
	xPEC0c = ReadSPI(0x00);
    x1d = ReadSPI(0x00);
	x2d = ReadSPI(0x00);
	x3d = ReadSPI(0x00);
    x4d = ReadSPI(0x00);
	x5d = ReadSPI(0x00);
	x6d = ReadSPI(0x00);
	xPEC1d = ReadSPI(0x00);
	xPEC0d = ReadSPI(0x00);
	CS=1;
    CS_test = CS;
// Write to Config A
    //killTime();
    unsigned short thresholdHigh=0x4E, thresholdLow=0x20; // ((High << 8)+Low)*16*100uV = VOV // 4E2 yields 2V
    CS=0;
    CS_test = CS;

    //Write command
	WriteReadSPI(0x00);
	WriteReadSPI(0x01);
    // Write PEC
        char z[2] = {0x00,0x01};
        u = pec15(z,2);	
        highbyte = (u >> 8);
        lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Write config A vals & overvoltage
	ReadSPI(x1);
	ReadSPI(0x00);
	ReadSPI(thresholdLow);
	ReadSPI(thresholdHigh);
	ReadSPI(x5);
	ReadSPI(x6);
        // Calculate PEC for write
        char  y[6] = {x1, 0x00, 0x20, 0x4E, x5, x6};
        u = pec15(y,6);	
        highbyte = (u >> 8);
        lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    //
    
    ReadSPI(x1b);
	ReadSPI(0x00);
	ReadSPI(thresholdLow);
	ReadSPI(thresholdHigh);
	ReadSPI(x5b);
	ReadSPI(x6b);
	ReadSPI(highbyte);
	ReadSPI(lowbyte);
    ReadSPI(x1c);
	ReadSPI(0x00);
	ReadSPI(thresholdLow);
	ReadSPI(thresholdHigh);
	ReadSPI(x5c);
	ReadSPI(x6c);
	ReadSPI(highbyte);
	ReadSPI(lowbyte);
    ReadSPI(x1d);
	ReadSPI(0x00);
	ReadSPI(thresholdLow);
	ReadSPI(thresholdHigh);
	ReadSPI(x5d);
	ReadSPI(x6d);
	ReadSPI(highbyte);
	ReadSPI(lowbyte);
	CS=1;
    CS_test = CS;

    
}

unsigned short errorMsg=0;
/* DONE FOR 4 BOARDS :: HAVE TO OUTPUT FLAG*///////////////////////////////////
void checkFlag(void){
    int flag=0;
    // initialize SPI data
    unsigned short boardType, sensorValue, errorType=192; // errorType 192 (over voltage) corresponds to 11 000000, 
                                                          //which is the first two bits of the error message
    
// Check SR B //    
	CS=0;
    CS_test = CS;

    //Write command for reading SR B
	WriteReadSPI(0x00);
	WriteReadSPI(0x12);
    // Write PEC
	char  x[2] = {0x00,0x12};
	unsigned short u = pec15(x,2);	
	unsigned short highbyte = (u >> 8);
	unsigned short lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Need to put u into the SPI
    //Read SR B
	unsigned short x1=0, x2=0, x3=0, x4=0, x5=0, x6=0, xPEC1 =0, xPEC0 = 0;
    unsigned short x1b=0, x2b=0, x3b=0, x4b=0, x5b=0, x6b=0, xPEC1b =0, xPEC0b = 0;
    unsigned short x1c=0, x2c=0, x3c=0, x4c=0, x5c=0, x6c=0, xPEC1c =0, xPEC0c = 0;
    unsigned short x1d=0, x2d=0, x3d=0, x4d=0, x5d=0, x6d=0, xPEC1d =0, xPEC0d = 0;
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
    if ((x3 > 0) ||(x4 > 0) || (x5 > 0)){
        flag = 1;
        LATCbits.LATC13 = 0;
    }
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    killTime();
    x1b = ReadSPI(0x00);
	x2b = ReadSPI(0x00);
	x3b = ReadSPI(0x00);
    x4b = ReadSPI(0x00);
	x5b = ReadSPI(0x00);
    if ((x3b > 0) ||(x4b > 0) || (x5b > 0)){
        flag = 2;
        LATCbits.LATC13 = 0;
    }
	x6b = ReadSPI(0x00);
	xPEC1b = ReadSPI(0x00);
	xPEC0b = ReadSPI(0x00);
    x1c = ReadSPI(0x00);
	x2c = ReadSPI(0x00);
	x3c = ReadSPI(0x00);
	x4c = ReadSPI(0x00);
	x5c = ReadSPI(0x00);
    if ((x3c > 0) ||(x4c > 0) || (x5c > 0)){
        flag = 3;
        LATCbits.LATC13 = 0;
    }
	x6c = ReadSPI(0x00);
	xPEC1c = ReadSPI(0x00);
	xPEC0c = ReadSPI(0x00);
    killTime();
    x1d = ReadSPI(0x00);
	x2d = ReadSPI(0x00);
	x3d = ReadSPI(0x00);
    x4d = ReadSPI(0x00);
	x5d = ReadSPI(0x00);
    if ((x3d > 0) ||(x4d > 0) || (x5d > 0)){
        flag = 4;
        LATCbits.LATC13 = 0;
    }
	x6d = ReadSPI(0x00);
	xPEC1d = ReadSPI(0x00);
	xPEC0d = ReadSPI(0x00);
	CS=1;
    CS_test = CS;

    /* Case statement for determining flag for voltages 1 to 12
    // in each AMS board*/
    switch(flag){
        case 0 :
            break;
        case 1:
            boardType=0; // A corresponds to cells 1-15, so add 0
            if(x3 > 0){
                x3 = x3 >> 3;       
                if(x3 > 0){
                    x3 = x3 >> 2;
                    if(x3 > 2){
                        /* C4 is triggered*/
                        sensorValue = 4 + boardType;
                    }else if(x3 == 0){
                        /*C2 is triggered*/
                        sensorValue = 2 + boardType;
                    }else if(x3 == 1){
                        /*C3 is triggered*/
                        sensorValue = 3 + boardType;
                    }
                }else if(x3 == 0){
                    /* C1 is triggered*/
                    sensorValue = 1 + boardType;
                }
            }else if(x4 > 0){
                x4 = x4 >> 3;       
                if(x4 > 0){
                    x4 = x4 >> 2;
                    if(x4 > 2){
                        /* C8 is triggered*/
                        sensorValue = 8 + boardType;
                    }else if(x4 == 0){
                        /*C6 is triggered*/
                        sensorValue = 6 + boardType;
                    }else if(x4 == 1){
                        /*C7 is triggered*/
                        sensorValue = 7 + boardType;
                    }
                }else if(x4 == 0){
                    /* C5 is triggered*/
                    sensorValue = 5 + boardType;
                }
            }else if(x5 > 0){
                x5 = x5 >> 3;       
                if(x5 > 0){
                    x5 = x5 >> 2;
                    if(x5 > 2){
                        /* C12 is triggered*/
                        sensorValue = 12 + boardType;
                    }else if(x5 == 0){
                        /*C10 is triggered*/
                        sensorValue = 10 + boardType;
                    }else if(x5 == 1){
                        /*C11 is triggered*/
                        sensorValue = 11 + boardType;
                    }
                }else if(x5 == 0){
                    /* C9 is triggered*/
                    sensorValue = 9 + boardType;
                }
            }
            break;
        case 2:
            boardType=15;//B corresponds to 16-30, so add 15
            if(x3b > 0){
                x3b = x3b >> 3;       
                if(x3b > 0){
                    x3b = x3b >> 2;
                    if(x3b > 2){
                        /* C4b is triggered*/
                        sensorValue = 4 + boardType;
                    }else if(x3b == 0){
                        /*C2b is triggered*/
                        sensorValue = 2 + boardType;
                    }else if(x3b == 1){
                        /*C3b is triggered*/
                        sensorValue = 3 + boardType;
                    }
                }else if(x3b == 0){
                    /* C1b is triggered*/
                    sensorValue = 1 + boardType;
                }
            }else if(x4b > 0){
                x4b = x4b >> 3;       
                if(x4b > 0){
                    x4b = x4b >> 2;
                    if(x4b > 2){
                        /* C8b is triggered*/
                        sensorValue = 8 + boardType;
                    }else if(x4b == 0){
                        /*C6b is triggered*/
                        sensorValue = 6 + boardType;
                    }else if(x4b == 1){
                        /*C7b is triggered*/
                        sensorValue = 7 + boardType;
                    }
                }else if(x4b == 0){
                    /* C5b is triggered*/
                    sensorValue = 5 + boardType;
                }
            }else if(x5b > 0){
                x5b = x5b >> 3;       
                if(x5b > 0){
                    x5b = x5b >> 2;
                    if(x5b > 2){
                        /* C12b is triggered*/
                        sensorValue = 12 + boardType;
                    }else if(x5b == 0){
                        /*C10b is triggered*/
                        sensorValue = 10 + boardType;
                    }else if(x5b == 1){
                        /*C11b is triggered*/
                        sensorValue = 11 + boardType;
                    }
                }else if(x5b == 0){
                    /* C9b is triggered*/
                    sensorValue = 9 + boardType;
                }
            }
            break;
        case 3:
            boardType=30;//C corresponds to 31-45, so add 30
            if(x3c > 0){
                x3c = x3c >> 3;       
                if(x3c > 0){
                    x3c = x3c >> 2;
                    if(x3c > 2){
                        /* C4c is triggered*/
                        sensorValue = 4 + boardType;
                    }else if(x3c == 0){
                        /*C2c is triggered*/
                        sensorValue = 2 + boardType;
                    }else if(x3c == 1){
                        /*C3c is triggered*/
                        sensorValue = 3 + boardType;
                    }
                }else if(x3c == 0){
                    /* C1c is triggered*/
                    sensorValue = 1 + boardType;
                }
            }else if(x4c > 0){
                x4c = x4c >> 3;       
                if(x4c > 0){
                    x4c = x4c >> 2;
                    if(x4c > 2){
                        /* C8c is triggered*/
                        sensorValue = 8 + boardType;
                    }else if(x4c == 0){
                        /*C6c is triggered*/
                        sensorValue = 6 + boardType;
                    }else if(x4c == 1){
                        /*C7c is triggered*/
                        sensorValue = 7 + boardType;
                    }
                }else if(x4c == 0){
                    /* C5c is triggered*/
                    sensorValue = 5 + boardType;
                }
            }else if(x5c > 0){
                x5c = x5c >> 3;       
                if(x5c > 0){
                    x5c = x5c >> 2;
                    if(x5c > 2){
                        /* C12c is triggered*/
                        sensorValue = 12 + boardType;
                    }else if(x5c == 0){
                        /*C10c is triggered*/
                        sensorValue = 10 + boardType;
                    }else if(x5c == 1){
                        /*C11c is triggered*/
                        sensorValue = 11 + boardType;
                    }
                }else if(x5c == 0){
                    /* C9c is triggered*/
                    sensorValue = 9 + boardType;
                }
            }
            break;
        case 4:
            boardType=45;//D corresponds to 46-60, so add 45
            if(x3d > 0){
                x3d = x3d >> 3;       
                if(x3d > 0){
                    x3d = x3d >> 2;
                    if(x3d > 2){
                        /* C4 is triggered*/
                        sensorValue = 4 + boardType;
                    }else if(x3d == 0){
                        /*C2 is triggered*/
                        sensorValue = 2 + boardType;
                    }else if(x3d == 1){
                        /*C3 is triggered*/
                        sensorValue = 3 + boardType;
                    }
                }else if(x3d == 0){
                    /* C1 is triggered*/
                    sensorValue = 1 + boardType;
                }
            }else if(x4d > 0){
                x4d = x4d >> 3;       
                if(x4d > 0){
                    x4d = x4d >> 2;
                    if(x4d > 2){
                        /* C8 is triggered*/
                        sensorValue = 8 + boardType;
                    }else if(x4d == 0){
                        /*C6 is triggered*/
                        sensorValue = 6 + boardType;
                    }else if(x4d == 1){
                        /*C7 is triggered*/
                        sensorValue = 7 + boardType;
                    }
                }else if(x4d == 0){
                    /* C5 is triggered*/
                    sensorValue = 5 + boardType;
                }
            }else if(x5d > 0){
                x5d = x5d >> 3;       
                if(x5d > 0){
                    x5d = x5d >> 2;
                    if(x5d > 2){
                        /* C12 is triggered*/
                        sensorValue = 12 + boardType;
                    }else if(x5d == 0){
                        /*C10 is triggered*/
                        sensorValue = 10 + boardType;
                    }else if(x5d == 1){
                        /*C11 is triggered*/
                        sensorValue = 11 + boardType;
                    }
                }else if(x5d == 0){
                    /* C9 is triggered*/
                    sensorValue = 9 + boardType;
                }
            }
            break;            
            
    }
            
// Check Aux Reg D
    CS=0;
    CS_test = CS;

    //Write command for reading SR B
	WriteReadSPI(0x00);
	WriteReadSPI(0x0F);
    // Write PEC
	char ox[2] = {0x00,0x0F};
	u = pec15(ox,2);	
	highbyte = (u >> 8);
	lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Need to put u into the SPI
    //Read SR B
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
    x5 = (0x2F & x5);
    
    /* C13 through C15 flags for AMS board 1*/
    if (x5 > 0){
       flag = 1;
       LATCbits.LATC13 = 0;
       x5 = x5 >> 3;
       if(x5 == 0){
           /* C13 is triggered */
           sensorValue = 13;
       }else if(x5 > 2){
           /* C15 is triggered */
           sensorValue = 15;
       }else if(x5 == 1){
           /* C14 is triggered*/
           sensorValue = 14;
       }
    }
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1b = ReadSPI(0x00);
	x2b = ReadSPI(0x00);
	x3b = ReadSPI(0x00);
    x4b = ReadSPI(0x00);
	x5b = ReadSPI(0x00);
    x5b = (0x2F & x5b);

    /* C13 through C15 flags for AMS board 2 */
    if (x5b > 0){
       flag = 1;
       LATCbits.LATC13 = 0;
       x5b = x5b >> 3;
       if(x5b == 0){
           /* C13 is triggered */
           sensorValue = 13+15;
       }else if(x5b > 2){
           /* C15 is triggered */
           sensorValue = 15+15;
       }else if(x5b == 1){
           /* C14 is triggered*/
           sensorValue = 14+15;
       }
    }
	x6b = ReadSPI(0x00);
	xPEC1b = ReadSPI(0x00);
	xPEC0b = ReadSPI(0x00);
	x1c = ReadSPI(0x00);
	x2c = ReadSPI(0x00);
	x3c = ReadSPI(0x00);
	x4c = ReadSPI(0x00);
	x5c = ReadSPI(0x00);
    x5c = (0x2F & x5);

    /* C13 through C15 flags for AMS board 3 */
    if (x5c > 0){
        flag = 1;
        LATCbits.LATC13 = 0;
       x5c = x5c >> 3;
       if(x5c == 0){
           /* C13 is triggered */
           sensorValue = 13+30;
       }else if(x5c > 2){
           /* C15 is triggered */
           sensorValue = 15+30;
       }else if(x5c == 1){
           /* C14 is triggered*/
           sensorValue = 14+30;
       }
    }
	x6c = ReadSPI(0x00);
	xPEC1c = ReadSPI(0x00);
	xPEC0c = ReadSPI(0x00);
    x1d = ReadSPI(0x00);
	x2d = ReadSPI(0x00);
	x3d = ReadSPI(0x00);
    x4d = ReadSPI(0x00);
	x5d = ReadSPI(0x00);
    x5d = (0x2F & x5b);
    /* C13 through C15 flags for AMS board 4 */
    if (x5d > 0){
        flag = 1;
        LATCbits.LATC13 = 0;
       x5d = x5d >> 3;
       if(x5d == 0){
           /* C13 is triggered */
           sensorValue = 13+45;
       }else if(x5d > 2){
           /* C15 is triggered */
           sensorValue = 15+45;
       }else if(x5d == 1){
           /* C14 is triggered*/
           sensorValue = 14+45;
       }
    }
	x6d = ReadSPI(0x00);
	xPEC1d = ReadSPI(0x00);
	xPEC0d = ReadSPI(0x00);
    //flag=1;
    //sensorValue = 46;
    if(flag > 0){
        errorMsg = errorType + sensorValue;
        LATCbits.LATC13 = 0;
    }else{
        errorMsg=0;
    }
	CS=1;
    CS_test = CS;

    //return errorMsg;
}
/* DONE FOR 4 BOARDS */////////////////////////////////////////////////////////
void checkVolts(void){
	CS=0;
    CS_test = CS;

	WriteReadSPI(0x03);
	WriteReadSPI(0x60);
	// Write PEC
	char  x[2] = {0x03,0x60};
	unsigned short u = pec15(x,2);	
	unsigned short highbyte = (u >> 8);
	unsigned short lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    WriteReadSPI(0x00);
    u = WriteReadSPI(0x00);
	while(u == 0x00){
        u = WriteReadSPI(0x00);
    }
	// Kill time for 2,537 us (for ADC conversion) + 4.4 ms for REFUP
	//killTimeCV();
    //killTimeCV();
    //killTimeCV();
    CS=1;
    CS_test = CS;

	// Read Cell Voltage Register A
	CS=0;
    CS_test = CS;

    //Write command
	WriteReadSPI(0x00);
	WriteReadSPI(0x04);
    // Write PEC
	x[0] = 0x00;
    x[1] = 0x04;
	u = pec15(x,2);	
	highbyte = (u >> 8);
	lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Need to put u into the SPI
    //Read PWM
	unsigned short x1=0, x2=0, x3=0, x4=0, x5=0, x6=0, xPEC1=0,xPEC0=0;
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
	CS=1;
    CS_test = CS;

}

/* DONE FOR 4 BOARDS EXCEPT FOR RETURN *///////////////////////////////////////

void checkSumOfVolts(void){
	CS=0;
    CS_test = CS;

	WriteReadSPI(0x05);
	WriteReadSPI(0x68);
	// Write PEC
	char  x[2] = {0x05,0x68};
	unsigned short u = pec15(x,2);	
	unsigned short highbyte = (u >> 8);
	unsigned short lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    WriteReadSPI(0x00);
    WriteReadSPI(0x00);
    WriteReadSPI(0x00);
    WriteReadSPI(0x00);
    u = WriteReadSPI(0x00);
	while(u == 0x00){
        u = WriteReadSPI(0x00);
    }
    
    CS=1;
    CS_test = CS;
 
    
    
	// Read Cell Voltage Register A
	CS=0;
    CS_test = CS;
 
    //Write command
	WriteReadSPI(0x00);
	WriteReadSPI(0x10);
    // Write PEC
	x[0] = 0x00;
    x[1] = 0x10;
	u = pec15(x,2);	
	highbyte = (u >> 8);
	lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Need to put u into the SPI
    //Read Sum of Volts -- each board writes out 8 bytes
	unsigned short x1=0, x2=0, x3=0, x4=0, x5=0, x6=0, xPEC1=0,xPEC0=0,sum1=0;
    unsigned short sum2=0, sum3=0, sum4=0;
    
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    sum1 = ((x2 << 8) & 0xFF00);
    sum1 = sum1 + x1;
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    Vreg1 = ((x6 << 8) & 0xFF00);
    Vreg1 = Vreg1 + x5;
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    sum2 = (x2 << 8) & 0xFF00;
    sum2 = sum2 + x1;
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    Vreg2 = ((x6 << 8) & 0xFF00);
    Vreg2 = Vreg2 + x5;
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    sum3 = (x2 << 8) & 0xFF00;
    sum3 = sum3 + x1;
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    Vreg3 = ((x6 << 8) & 0xFF00);
    Vreg3 = Vreg3 + x5;
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    sum4 = (x2 << 8)& 0xFF00;
    sum4 = sum4 + x1;
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    Vreg4 = ((x6 << 8) & 0xFF00);
    Vreg4 = Vreg4 + x5;
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
	CS=1;
    CS_test = CS;

    sumAll = (sum4 + sum1 + sum2 + sum3); // Send sumAll to the master
    endSum = (((float) sumAll)*100*30/1000000);
    //LCD_setpos(0,0);
    //printf("Battery pack is at %3.2f Volts.");

    
    /* When printing this, cast as float and divide by 10^6
    // which is the actual value of the sum of cells. 
    // for simplicity, use %3.2f in printf statement */
    
}
/* Read Aux will read the given register, and compute the avg
// temperature of the three sensors. Then it will add to a
// recurring count of the averages. currentTemp should be
// zeroed before calling ReadAux. After ReadAux has been called
// for all registers, currentTemp will be the sum of the four
 / average temperatures, so it must be divided by 4 to get the
 / true average. */
void ReadAux(unsigned short cmd0, unsigned short cmd1, char* registerAux, int regCount){
    // Read Aux Register A :: cmd0 = 0x00 cmd1 = 0x0C
	
    unsigned short Vreg;
    unsigned short sensorValue, errorType=0x80, boardType;
    regCount=0;
    int flag=0;
    int numOfGPIOs=0; // This could be wrong. Check. It's for calculating averages
    if(registerAux == "A"){
        regCount = 0;
        numOfGPIOs=8;
    }else if(registerAux == "B"){
        regCount = 3;
        numOfGPIOs = 8;
    }else if(registerAux == "C"){
        regCount = 5;
        numOfGPIOs=12;
    }else if(registerAux == "D"){
        regCount = 8;
        numOfGPIOs=2;
    }
    CS=0;
    CS_test = CS;
    
    //Write command
	WriteReadSPI(cmd0);
	WriteReadSPI(cmd1);
    // Write PEC
    char  x[2];
	x[0] = cmd0;
    x[1] = cmd1;
	unsigned short u = pec15(x,2);	
	unsigned short highbyte = (u >> 8);
	unsigned short lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    // Need to put u into the SPI
    //Read Sum of Volts -- each board writes out 8 bytes
	unsigned short x1=0, x2=0, x3=0, x4=0, x5=0, x6=0, xPEC1=0,xPEC0=0;
    unsigned long G1V, G2V, G3V, G1Vb, G2Vb, G3Vb, G1Vc, G2Vc, G3Vc, G1Vd, G2Vd, G3Vd;
    unsigned short threshold;
    
/* First board*/
    // threshold for board 1;  //
    Vreg = Vreg1;
    threshold = (float) Vreg*.01984;
    
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    G1V = (x2 << 8);
    G1V = G1V + x1;
    if(registerAux == "D"){
        G1V = 0;
    }
    if(G1V < threshold && registerAux != "D"){
        flag=1;
        sensorValue = regCount+1;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 1+regCount on board 1 in Aux Reg %c is above threshold", registerAux);*/
    }
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
    G2V = (x4 << 8);
    G2V = G2V + x3;
    if(registerAux == "D"){
        G2V = 0;
    }
    if(G2V < threshold && registerAux != "D"){
        flag=2;
        sensorValue = regCount+2;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 2+regCount in Board 1 is above threshold", registerAux);*/
    }
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    G3V = (x6 << 8);
    G3V = G3V + x5;
    if(registerAux == "B" || registerAux == "D" || registerAux == "A"){
        G3V = 0;
    }
    if(G3V < threshold && registerAux != "A" && registerAux != "D" && registerAux != "B"){
        flag=3;
        sensorValue = regCount+3;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 3+regCount in Board 1 is above threshold", registerAux);*/
    }
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
/* Second board*/
    Vreg = Vreg2;
    threshold = (float) Vreg*.01984;
    regCount = regCount + 8;
    
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    G1Vb = (x2 << 8);
    G1Vb = G1Vb + x1;
    if(G1Vb < threshold){
        flag=4;
        sensorValue = regCount+1;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 1+regCount in Board 2 is above threshold", registerAux);*/
    }
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
    G2Vb = (x4 << 8);
    G2Vb = G2Vb + x3;
    if(registerAux == "D"){
        G2Vb = 0;
    }
    if(G2Vb < threshold && registerAux != "D"){
        flag=5;
        sensorValue = regCount+2;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 2+regCount in Board 1 is above threshold", registerAux);*/
    }
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    G3Vb = (x6 << 8);
    G3Vb = G3Vb + x5;
    if(registerAux == "B" || registerAux == "D" || registerAux == "A"){
        G3Vb = 0;
    }
    if(G3Vb < threshold && registerAux != "A" && registerAux != "D" && registerAux != "B"){
        flag=6;
        sensorValue = regCount+3;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 3+regCount in Board 1 is above threshold", registerAux);*/
    }
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
/* Third board*/
    Vreg = Vreg3;
    threshold = (float) Vreg*.01984;
    regCount = regCount + 7;
    
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    G1Vc = (x2 << 8);
    G1Vc = G1Vc + x1;
    if(G1Vc < threshold){
        flag=7;
        sensorValue = regCount+1;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 1+regCount in Board 3 is above threshold", registerAux);*/
    }
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
    G2Vc = (x4 << 8);
    G2Vc = G2Vc + x3;
    if(registerAux == "D"){
        G2Vc = 0;
    }
    if(G2Vc < threshold && registerAux != "D"){
        flag=8;
        sensorValue = regCount+2;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 2+regCount in Board 1 is above threshold", registerAux);*/
    }
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    G3Vc = (x6 << 8);
    G3Vc = G3Vc + x5;
    if(registerAux == "B" || registerAux == "D" || registerAux == "A"){
        G3Vc = 0;
    }
    if(G3Vc < threshold && registerAux != "A" && registerAux != "D" && registerAux != "B"){
        flag=9;
        sensorValue = regCount+3;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 3+regCount in Board 1 is above threshold", registerAux);*/
    }
	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
/* Fourth board*/
    Vreg = Vreg4;
    threshold = (float) Vreg*.01984;
    regCount = regCount + 7;
    
	x1 = ReadSPI(0x00);
	x2 = ReadSPI(0x00);
    G1Vd = (x2 << 8);
    G1Vd = G1Vd + x1;
    if(registerAux == "D"){
        G1Vd = 0;
    }
    if(G1Vd < threshold && registerAux != "D"){
        flag=10;
        sensorValue = regCount+1;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 1+regCount in Board 4 is above threshold", registerAux);*/
    }
	x3 = ReadSPI(0x00);
	x4 = ReadSPI(0x00);
    G2Vd = (x4 << 8);
    G2Vd = G2Vd + x3;
    if(registerAux == "D"){
        G2Vd = 0;
    }
    if(G2Vd < threshold && registerAux != "D"){
        flag=11;
        sensorValue = regCount+2;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 2+regCount in Board 1 is above threshold", registerAux);*/
    }
	x5 = ReadSPI(0x00);
	x6 = ReadSPI(0x00);
    G3Vd = (x6 << 8);
    G3Vd = G3Vd + x5;
    if(registerAux == "B" || registerAux == "D" || registerAux == "A"){
        G3Vd = 0;
    }
    if(G3Vd < threshold && registerAux != "A" && registerAux != "D" && registerAux != "B"){
        flag=12;
        sensorValue = regCount+3;
        LATCbits.LATC13 = 0;
        /* printf("Temperature sensor 3+regCount in Board 1 is above threshold", registerAux);*/
    }

	xPEC1 = ReadSPI(0x00);
	xPEC0 = ReadSPI(0x00);
    
	CS=1;
    CS_test = CS;
    
    if(flag > 0){
        errorMsg = errorType + sensorValue;
        LATCbits.LATC13 = 0;
    }else{
        errorMsg=0;
    }
    
    currentTemp = currentTemp + (float) (G1V+G1Vb+G1Vc+G1Vd+G2V+G2Vb+G2Vc+G2Vd+G3V+G3Vb+G3Vc+G3Vd)/numOfGPIOs;
    
}
void readTemperatures(void){
	CS=0;
    CS_test = CS;

	WriteReadSPI(0x05);
	WriteReadSPI(0x60);
	// Write PEC 0b0
	char  x[2] = {0x05,0x60};
	unsigned short u = pec15(x,2);	
	unsigned short highbyte = (u >> 8);
	unsigned short lowbyte = (u & 0x00FF);
	WriteReadSPI(highbyte);
	WriteReadSPI(lowbyte);
    WriteReadSPI(0x00);
    u = WriteReadSPI(0x00);
    u = WriteReadSPI(0x00);
    u = WriteReadSPI(0x00);
    u = WriteReadSPI(0x00);
	while(u == 0x00){
        u = WriteReadSPI(0x00);
    }
    CS=1;
    CS_test = CS;
 
    currentTemp = 0;
    /* Read D */
    ReadAux(0x00, 0x0F, "D", 8);
    /* Read C */
    ReadAux(0x00, 0x0D, "C", 5);
    /* Read B */
    ReadAux(0x00, 0x0E, "B", 3);
    /* Read A */
    ReadAux(0x00, 0x0C, "A", 0);
    
    float savedTemp1 = (float) currentTemp/4/10000; 
    float Vreg_Avg = (float) (Vreg1 + Vreg2 + Vreg3 + Vreg4)/4/10000;
    float Vratio1 = savedTemp1 / Vreg_Avg;
    float Rt = 10000*Vratio1/(1-Vratio1);
    float V_Rt = Vreg_Avg * Rt / (Rt+10000);
    float temp_B_ln = 3933 / (log(Rt/10000));
    tempFinal = ((float) temp_B_ln*298/(temp_B_ln+298));

    currentTemp=0;
}
/////////////// TWO CALLS OF THIS WAKES UP ONE BOARD //////////////////////////
void WakeUpAMS(void){
    // Set differential activity by keeping clock high on idle and CS low
    CS = 0;
    CS_test = CS;
    // Wait for t-dwell = 240 ns
    //killTime();
    // Wait for t-wake. HAS TO BE 400 us at least
    killTime();
    killTime();
    killTime();
    killTime();
    killTime();
    killTime();
    killTime();
    CS=1;
    CS_test = CS;

}
///////////////////////////////////////////////////////////////////////////////
void killTime(void){
    int x=0;
    // Wait for 60 us
    while(x<84){
        x=x+1;
    }
}
void initSPI(void){
    CS = 1;                     // Set CS high (idle state)
    CS_test = CS;
   
    CNPUEbits.CNPUE9 = 1;
    CNPUEbits.CNPUE10 = 1;

    
    AD1PCFG = 0xFFFF;           // set all pins to digital
    DDPCON = 0x0000;            // disable JTAG
    IEC1bits.SPI2EIE = 0;       // SPI interrupts disabled
    IEC1bits.SPI2RXIE = 0;
    IEC1bits.SPI2TXIE = 0;
    SPI2CONbits.ON = 0;         // Turn off SPI module
     
    SPI2BUF = 0;                // Clear the receive buffer
     
    SPI2BRG = 19;                // FSCK = 1MHz
     //SPI4BRG = 0;                // FSCK = 20MHz (once we get it working)
     
    SPI2STATbits.SPIROV = 0;    // Clear overflow flag
     
     
    /* SPI1CON settings */
    SPI2CONbits.FRMEN = 0;      // Framed SPI support is disabled
    SPI2CONbits.SIDL = 0;       // Continue operation in IDLE mode
    SPI2CONbits.DISSDO = 0;     // SDO1 pin is controlled by the module

    // WAS CKP = 1, CKE =0 with translator board
    SPI2CONbits.CKP = 0;        // Idle state for clock is high, active state is low, on rising edge
    SPI2CONbits.CKE = 1; //changed it from 0       // Output data changes on transition from idle to active
    SPI2CONbits.SSEN = 0;       // Not in slave mode
    SPI2CONbits.MSTEN = 1;      // Master mode
    SPI2CONbits.SMP = 0;        // Input data sampled at the middle of data output time
     
    SPI2CONbits.ON = 1;         // Turn module on
}

short WriteReadSPI(unsigned short i){
    //killTime();
    SPI2BUF = i;                    // Write to buffer for transmission
    while (!SPI2STATbits.SPIRBF);   // Wait for transfer to be completed
    return SPI2BUF;                 // Return the received value
}

short ReadSPI(unsigned short i){
    //killTime();
    SPI2BUF = i;                    // Write to buffer for transmission
    while (!SPI2STATbits.SPIRBF);   // Wait for transfer to be completed
    //unsigned short x = SPI2BUF;
    return SPI2BUF;                 // Return the received value
}
/* This function will...
 /// :: Write the overvoltage value to the appropriate registers
 /// :: Check the individual voltage of cells (necessary to trigger overvoltage flag 
 /// :: Check to see the if the flag is triggered and output either 1 or 0 to a variable*/

unsigned short xFlag=0;
void OvervoltageCode(void){
    //LED=0;
    checkVolts();
    checkFlag();
}

void WakeUp4Boards(void){
    /* WakeUp AMS has to be called twice per daisy-chained board*/
    WakeUpAMS();
    WakeUpAMS();
    WakeUpAMS();
    WakeUpAMS();
    WakeUpAMS();
    WakeUpAMS();
    WakeUpAMS();
    WakeUpAMS();
}
void initSPI_slave3(){
    AD1PCFG = 0xFFFF;           // set all pins to digital
    DDPCON = 0x0000;            // disable JTAG
    IEC0bits.SPI3EIE = 0;       // SPI interrupts disabled
    IEC0bits.SPI3RXIE = 0;
    IEC0bits.SPI3TXIE = 0;
// Reset module
    SPI3CONbits.ON = 0;         // Turn off SPI module
// Clear the receive buffer
    SPI3BUF = 0;                
    
    SPI3BRG = 19;                // FSCK = 1MHz
   
// Clear flags, set priority, and enable SPI interrupt
    IFS0bits.SPI3EIF = 0;
    IFS0bits.SPI3RXIF = 0;
    IFS0bits.SPI3TXIF = 0;
    IPC6bits.SPI3IP = 1;
    //IEC0bits.SPI3EIE = 1;
    IEC0bits.SPI3RXIE = 1;
    
// Clear overflow flag
    SPI3STATbits.SPIROV = 0;    
     
    /* SPI1CON settings */
    SPI3CONbits.FRMEN = 0;      // Framed SPI support is disabled
    SPI3CONbits.SIDL = 0;       // Continue operation in IDLE mode
    SPI3CONbits.DISSDO = 0;     // SDO1 pin is controlled by the module
    //SPI3CONbits.MODE16 = 1;     // 16 bit mode
    //SPI2CONbits.MODE32 = 0;
    SPI3CONbits.CKP = 0;        // Idle state for clock is high, active state is low, on rising edge
    SPI3CONbits.CKE = 1; //changed it from 0       // Output data changes on transition from idle to active
    SPI3CONbits.SSEN = 1;       // in slave mode
    SPI3CONbits.MSTEN = 0;      // Master mode
    SPI3CONbits.SMP = 0;        // Input data sampled at the middle of data output time
    
    SPI3CONbits.ON = 1;         // Turn module on
}
void initSPI4_slave(void){    
   AD1PCFG = 0xFFFF;           // set all pins to digital
    DDPCON = 0x0000;            // disable JTAG
    
    CNPUEbits.CNPUE17 = 1;
    CNPUEbits.CNPUE18 = 1;
    
    IEC1bits.SPI4EIE = 0;       // SPI interrupts disabled
    IEC1bits.SPI4RXIE = 0;
    IEC1bits.SPI4TXIE = 0;
// Reset module
    SPI4CONbits.ON = 0;         // Turn off SPI module
// Clear the receive buffer
    SPI4BUF = 0;                
    
    SPI4BRG = 19;                // FSCK = 1MHz
   
// Clear flags, set priority, and enable SPI interrupt
    IFS1bits.SPI4EIF = 0;
    IFS1bits.SPI4RXIF = 0;
    IFS1bits.SPI4TXIF = 0;
    IPC8bits.SPI4IP = 1;
    //IPC8bits.SPI4IS = 1;
    //IEC1bits.SPI4EIE = 1;
    IEC1bits.SPI4RXIE = 1;
    //IEC1bits.SPI4TXIE = 1;
    
// Clear overflow flag
    SPI4STATbits.SPIROV = 0;    
     
    /* SPI1CON settings */
    SPI4CONbits.FRMEN = 0;      // Framed SPI support is disabled
    SPI4CONbits.SIDL = 0;       // Continue operation in IDLE mode
    SPI4CONbits.DISSDO = 0;     // SDO1 pin is controlled by the module
    //SPI3CONbits.MODE16 = 1;     // 16 bit mode
    //SPI2CONbits.MODE32 = 0;
    SPI4CONbits.CKP = 0;        // Idle state for clock is high, active state is low, on rising edge
    SPI4CONbits.CKE = 1; //changed it from 0       // Output data changes on transition from idle to active
    SPI4CONbits.SSEN = 1;       // in slave mode
    SPI4CONbits.MSTEN = 0;      // Master mode
    SPI4CONbits.SMP = 0;        // Input data sampled at the middle of data output time
    
    SPI4CONbits.ON = 1;         // Turn module on
}

void __ISR(24, IPL1SOFT) SPI3_ISR(void){

    unsigned short temp=0;
    unsigned short lowB = sumAll & 0x00FF, highB =(sumAll >> 8) & 0x00FF ;
 
   // unsigned short lowB = sumAll & 0x00FF, highB =(sumAll >> 8) & 0x00FF ;
    while (!SPI3STATbits.SPIRBF);  
    temp =SPI3BUF;
    switch(temp){
        case 0xFA:
            SPI3BUF = highB;  // high byte of SC received on next transaction   
            break;
        case 0xFB: 
            SPI3BUF = lowB; // low byte -> next transaction
            break;
        case 0xFC:
            SPI3BUF = errorMsg; // error MSG
            break;
        case 0xFD:
            SPI3BUF = tempFinal - 200;
            break;
        case 0xFE:
            SPI3BUF = 0x00;
            break;
    }
     IFS0bits.SPI3EIF = 0;
    IFS0bits.SPI3RXIF = 0;
    IFS0bits.SPI3TXIF = 0;
}

void initTimer3(void){
    
    /* Enable interrupts */
//    TRISDbits.TRISD0 = 0; (not needed in think)
//    AD1PCFG = 0xFFFF; // everything digital (moved to initIO)
    
    /* Initialize timer 3 interrupt bits */
    IEC0bits.T3IE = 1; // enable timer3 interrupt
    IPC3bits.T3IP = 0b100; //int priority -- 4

    /* Enable timer 3 */
    T3CONbits.ON = 0; // turn it off
    TMR3 = 0; // clear any count
    
    /* Set timer length
     * PR*PreScale = 128*100000 = 25,600,000
     * 80Mhz/(PR*PreScale) = 6.25 */
    PR3 = 25000; // 5 secs at 100,000 and Tcharge = 7
    T3CONbits.TCKPS = 0b111; // divide by 256
    
//    asm("ei"); // enable interrupts (moved to initInterrupt)
    T3CONbits.ON = 1; // turn on timer3
    
}



/* Timer 3 Interrupt Service Routine */
/* vector number for T3 is 12, Priority 6 */
void __ISR(12, IPL6AUTO) Timer3Hand(void){

    if(T_charge < 4) {
        T_charge = T_charge+1;
    }
    if(T_charge == 4){
        LATCbits.LATC13 = 0;
    }


    IFS0bits.T3IF = 0; // clear interrupt flag
}

    
int main(int argc, char** argv){
    unsigned short buff=0,count=0;
    initSPI();
    TRISCbits.TRISC13 = 0;
    LATCbits.LATC13 = 1;
    init_PEC15_Table();
    TRISDbits.TRISD7 = 0;
    PORTDbits.RD7 = 1;
    TRISEbits.TRISE5 = 0;

                      // initialize SPI module
    WakeUp4Boards();
    writeOV();                  // Write Overvoltage values once
    INTCONbits.MVEC = 1; // set multivectored interrupts
    asm("ei");
    int count0=0;
    initTimer3();
    while(1){
        T_charge=0;
        checkSumOfVolts();
        T_charge=0;
        OvervoltageCode();
        T_charge=0;
        if(count0 == 0){ 
            initSPI_slave3();
            count0++;
        }
        readTemperatures();
    }
    
    
    return (EXIT_SUCCESS);
}

